<script setup lang="ts">
  defineEmits<{
    (e: 'close'): void;
  }>();

  withDefaults(
    defineProps<{
      visible?: boolean;
    }>(),
    {
      visible: false,
    },
  );

  // const { t } = useI18n();
  // const { clients, self, controlledClient, setControlledClient, permissionGranted } =
  //   useParticipants();
  // const { requestTokenPermission, resetCart } = useCart();
  // const { resetLikeList } = useLikeList();
  const { lastSeenProducts, loadLastSeen, lastSeenCount, isLastSeenLoading } = useLastSeen();

  onBeforeMount(() => {
    loadLastSeen();
  });

  // const searchValue = ref();

  // const ALL_PARTICIPANTS = {
  //   attendeeId: 'all',
  //   attendeeName: t('presentation.selectParticipant'),
  // };
  // const GUIDE_PARTICIPANTS = {
  //   attendeeId: 'guide',
  //   attendeeName: `${self.value?.attendeeName} (${t('guide')})`,
  // };
  // const participants = computed(() => [
  //   // ALL_PARTICIPANTS,
  //   GUIDE_PARTICIPANTS,
  //   ...Object.values(clients.value),
  // ]);
  // const selectedParticipant = ref(
  //   controlledClient.value ? controlledClient.value : ALL_PARTICIPANTS,
  // );
  // const showAllClientList = computed(
  //   () => isGuide.value && selectedParticipant.value?.attendeeId === ALL_PARTICIPANTS.attendeeId,
  // );
  // const showGuideList = computed(
  //   () => isGuide.value && selectedParticipant.value?.attendeeId === GUIDE_PARTICIPANTS.attendeeId,
  // );

  const displayedLineItems = computed(() => {
    // if (showAllClientList.value) {
    //   const regex = new RegExp(searchValue.value, 'i');
    //   return likeList.value.filter((item) => regex.test(item.name ?? ''));
    // } else {
    //   return likeList.value;
    // }

    return lastSeenProducts.value;
  });

  // watch(
  //   selectedParticipant,
  //   async (participant) => {
  //     if (isGuide.value && participant) {
  //       searchValue.value = '';

  //       if (participant.attendeeId === GUIDE_PARTICIPANTS.attendeeId) {
  //         await loadGuideLastSeen();
  //         resetLikeList();
  //         resetCart();
  //       } else if (participant.attendeeId === ALL_PARTICIPANTS.attendeeId) {
  //         setControlledClient(undefined);
  //       } else {
  //         setControlledClient(participant.attendeeId);
  //       }
  //     }
  //   },
  //   {
  //     immediate: true,
  //   },
  // );
</script>

<template>
  <SwSidebar
    :visible="visible"
    class="w-100vw sm:w-100"
    :show-back-btn="false"
    name="cart-sidebar"
    @close="$emit('close')"
  >
    <template #header>
      <div class="flex w-full flex-col gap-3">
        <slot name="header-title">
          <div>
            <p class="text-xl font-bold">
              {{ $t('lastSeen.header') }}
            </p>
            <span class="text-(xs information-subdued)">
              {{
                lastSeenCount ? $t('cart.products', { p: lastSeenCount }) : $t('cart.noProducts')
              }}
            </span>
          </div>
        </slot>
        <slot name="participant-selector">
          <!-- <SwSelect
            v-if="isGuide"
            v-model="selectedParticipant"
            :options="participants"
            label-field="attendeeName"
            key-field="attendeeId"
            return-object-value
            :label="$t('participant')"
            :placeholder="$t('participant')"
          /> -->

          <!-- <SwButton
            v-if="permissionGranted"
            @click="requestTokenPermission(selectedParticipant.attendeeId)"
            >{{ $t('presentation.participants.requestCartPermission') }}</SwButton
          > -->
        </slot>
        <!-- <div v-if="showAllClientList" class="flex gap-3">
          <SwSearchInput class="w-full" @change="onSearchChanged" />
          <SwDropDown>
            <template #trigger-button="{ open }">
              <SwButton variant="action" size="medium" @click="open">
                <template #icon>
                  <span class="i-sw-solid:sort text-base" />
                </template>
                <template #default>
                  <span class="capitalize">{{ $t('sort') }}</span>
                </template>
              </SwButton>
            </template>
            <template #content>
              <button
                class="hover:bg-interactive-pressed rounded-2 relative flex h-6 items-center px-2 py-1 text-left capitalize"
                @click="changeFilter('quantity', 'desc')"
              >
                <span
                  v-if="allCartsFilter?.order === 'quantity'"
                  class="i-sw-regular:checkmark-xs text-primary absolute bottom-0 left-0"
                />
                <span :class="['pl-4', { 'text-primary': allCartsFilter?.order === 'quantity' }]">{{
                  $t('quantity')
                }}</span>
              </button>
              <button
                class="hover:bg-interactive-pressed rounded-2 relative flex h-6 items-center px-2 py-1 text-left capitalize"
                @click="changeFilter('revenue', 'desc')"
              >
                <span
                  v-if="allCartsFilter?.order === 'revenue'"
                  class="i-sw-regular:checkmark-xs text-primary absolute bottom-0 left-0"
                />
                <span :class="['pl-4', { 'text-primary': allCartsFilter?.order === 'revenue' }]">{{
                  $t('revenue')
                }}</span>
              </button>
              <button
                class="hover:bg-interactive-pressed rounded-2 relative flex h-6 items-center px-2 py-1 text-left capitalize"
                @click="changeFilter('name', 'asc')"
              >
                <span
                  v-if="allCartsFilter?.order === 'name'"
                  class="i-sw-regular:checkmark-xs text-primary absolute bottom-0 left-0"
                />
                <span :class="['pl-4', { 'text-primary': allCartsFilter?.order === 'name' }]">{{
                  $t('A-Z')
                }}</span>
              </button>
            </template>
          </SwDropDown>
        </div> -->
      </div>
    </template>

    <template #body>
      <SwLoading
        v-if="isLastSeenLoading"
        class="text-primary z-loading absolute inset-0 bg-white text-3xl"
      />
      <div
        v-if="lastSeenCount === 0"
        class="flex h-full flex-col items-center justify-center p-10 text-center"
      >
        <div class="bg-background-raised text-information-subdued mb-4 rounded-full p-6">
          <span class="i-sw-solid:history" />
        </div>
        <p class="text-(base information-dark) mb-1 font-semibold">
          {{ $t('lastSeen.emptyLabel') }}
        </p>
        <p class="text-(sm information-subdued)">
          {{ $t('lastSeen.emptyDescription') }}
        </p>
      </div>

      <div v-else>
        <div class="flex flex-col px-6">
          <div v-for="product of displayedLineItems" :key="product?.id">
            <SwLastSeenProductItem :data="product" />
          </div>
        </div>
      </div>
    </template>
  </SwSidebar>
</template>
